package cn.com.poc.agent_application.rest;

import cn.com.poc.agent_application.dto.AgentApplicationInfoSearchDto;
import cn.com.poc.agent_application.dto.AgentApplicationPreviewDto;
import cn.com.poc.agent_application.dto.BizAgentApplicationLargeModelListDto;
import cn.com.yict.framemax.core.rest.BaseRest;
import cn.com.poc.agent_application.dto.AgentApplicationInfoDto;
import cn.com.yict.framemax.data.model.PagingInfo;

import java.util.List;

import cn.com.yict.framemax.web.permission.Access;
import cn.com.yict.framemax.web.permission.Permission;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletResponse;

@Permission(value = Access.Safety)
public interface AgentApplicationInfoRest extends BaseRest {

    /**
     * 获取应用详情
     */
    AgentApplicationInfoDto getInfo(@RequestParam String agentId) throws Exception;

    /**
     * 获取用户创建应用列表
     */
    List<AgentApplicationInfoDto> getListByMember(@RequestBody AgentApplicationInfoSearchDto dto, PagingInfo pagingInfo) throws Exception;

    /**
     * 创建应用
     */
    AgentApplicationInfoDto saveOrUpdate(@RequestBody AgentApplicationInfoDto dto) throws Exception;

    /**
     * 更新应用
     */
    AgentApplicationInfoDto update(@RequestBody AgentApplicationInfoDto dto) throws Exception;

    /**
     * 删除应用
     */
    void delete(@RequestParam String agentId) throws Exception;

    /**
     * 更新并发布应用
     */
    boolean updateAndPublish(@RequestBody AgentApplicationInfoDto dto) throws Exception;

    /**
     * 应用预览
     */
    void preview(@RequestBody AgentApplicationPreviewDto dto, HttpServletResponse response) throws Exception;

    /**
     * 获取应用模型列表
     */
    List<BizAgentApplicationLargeModelListDto> getLargeModelList() throws Exception;
}